Index: src/backend/parser/parse_utilcmd.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/parser/parse_utilcmd.c,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.10.5
diff -c -r1.1.1.1 -r1.1.1.1.10.5
*** src/backend/parser/parse_utilcmd.c	1 Dec 2008 09:36:26 -0000	1.1.1.1
--- src/backend/parser/parse_utilcmd.c	13 Mar 2009 09:09:36 -0000	1.1.1.1.10.5
***************
*** 75,80 ****
--- 75,81 ----
  	List	   *alist;			/* "after list" of things to do after creating
  								 * the table */
  	IndexStmt  *pkey;			/* PRIMARY KEY index, if any */
+ 	PartitionAttrs *partAttr; 	/* partitioning related info */
  } CreateStmtContext;
  
  /* State shared by transformCreateSchemaStmt and its subroutines */
***************
*** 114,119 ****
--- 115,121 ----
  static void transformConstraintAttrs(List *constraintList);
  static void transformColumnType(ParseState *pstate, ColumnDef *column);
  static void setSchemaName(char *context_schema, char **stmt_schema_name);
+ static void transformPartitionData(ParseState *pstate, CreateStmtContext *cxt);
  
  
  /*
***************
*** 177,182 ****
--- 179,185 ----
  	cxt.alist = NIL;
  	cxt.pkey = NULL;
  	cxt.hasoids = interpretOidsOption(stmt->options);
+ 	cxt.partAttr = (PartitionAttrs *)stmt->partAttr;
  
  	/*
  	 * Run through each primary element in the table creation clause. Separate
***************
*** 235,240 ****
--- 238,248 ----
  	transformFKConstraints(pstate, &cxt, true, false);
  
  	/*
+ 	 * Postprocess partition related information
+ 	 */
+ 	transformPartitionData(pstate, &cxt);
+ 
+ 	/*
  	 * Output results.
  	 */
  	stmt->tableElts = cxt.columns;
***************
*** 955,960 ****
--- 963,1063 ----
  	return result;
  }
  
+ /*
+  * transformPartitionData:
+  * If partitioning is specified, carry out checks on the supplied create stmt
+  */
+ static void
+ transformPartitionData(ParseState *pstate, CreateStmtContext *cxt)
+ {
+ 	PartitionAttrs 	*partAttr = (PartitionAttrs *)cxt->partAttr;
+ 	ListCell 		*lc, *temp_part; 
+ 	List *partitionList, *partindexlist = NIL;
+ 
+ 	if (partAttr == NULL)
+ 		return;
+ 
+ 	partitionList = partAttr->partitions;
+ 	/* Foreign key constraints not supported with partitioning */
+ 	if(cxt->fkconstraints)
+ 		ereport(ERROR,
+ 				(errcode(ERRCODE_INVALID_TABLE_DEFINITION),
+ 				 errmsg("FOREIGN KEY constraints not supported with partitioning")));
+ 
+ 	/*
+ 	 * Check if the primary key column is the one on which partitioning
+ 	 * is being done
+ 	 */
+ 
+ 	foreach(lc, cxt->ixconstraints)
+ 	{
+ 		Constraint  *constraint = lfirst(lc);
+ 		ListCell *partCol;
+ 		bool 	flag;
+ 
+ 		Assert(IsA(constraint, Constraint));
+ 
+ 		if(constraint->contype == CONSTR_PRIMARY ||
+ 		   constraint->contype == CONSTR_UNIQUE) 
+ 		{
+ /*
+ 			if (constraint->keys->length > 1) 
+ 			{
+ 				ereport(ERROR,
+ 						(errcode(ERRCODE_INVALID_TABLE_DEFINITION),
+ 						 errmsg("PRIMARY/UNIQUE KEY with partitioning can specify"
+ 								" single attribute only")));
+ 			}
+ */
+ 			flag = false;
+ 
+ 			foreach(partCol, partAttr->colName)
+ 			{
+ 				Alias *partColName = lfirst(partCol);
+ 
+ 				if(strcmp(partColName->aliasname, strVal(lfirst(list_head(constraint->keys)))) == 0)
+ 					flag = true;
+ 			}
+ 
+ 			if(flag == false)			
+ 			{
+ 				ereport(ERROR,
+ 						(errcode(ERRCODE_INVALID_TABLE_DEFINITION),
+ 						 errmsg("PRIMARY/UNIQUE KEY (%s) not the same as"
+ 								" the partitioning keys", strVal(lfirst(list_head(constraint->keys))))));
+ 			}
+ 		}
+ 	}
+ 
+ 	/*
+ 	 * cxt.alist contains index related entries, if so, we need to add entries
+ 	 * for the children tables too
+ 	 */
+ 	foreach(temp_part, partitionList)
+ 	{
+ 		Partition *temp_partition = lfirst(temp_part);
+ 
+ 		foreach(lc, cxt->alist)
+ 		{
+ 			IndexStmt  *index, *copyindex;
+ 
+ 			index = lfirst(lc);
+ 			Assert(IsA(index, IndexStmt));
+ 
+ 			copyindex = copyObject(index);
+ 			*(copyindex->relation) = *(temp_partition->partName);
+ 
+ 			partindexlist = lappend(partindexlist, copyindex);
+ 		}
+ 	}
+ 
+ 	/*
+ 	 * Append partindexlist to alist now, so that the indexes get created for
+ 	 * the children tables too
+ 	 */
+ 	cxt->alist = list_concat(cxt->alist, partindexlist);
+ }
+ 
  
  /*
   * transformIndexConstraints
***************
*** 1770,1775 ****
--- 1873,1890 ----
  				cmd->subtype = AT_AddConstraint;
  				newcmds = lappend(newcmds, cmd);
  				break;
+ 
+ 			case AT_AddPartition:
+ 				newcmds = lappend(newcmds, cmd);
+ 				break;		
+ 
+ 			case AT_DropPartitionByName:
+ 				newcmds = lappend(newcmds, cmd);
+ 				break;		
+ 
+ 			case AT_DropPartitionByRange:
+ 				newcmds = lappend(newcmds, cmd);
+ 				break;		
  
  			default:
  				newcmds = lappend(newcmds, cmd);
Index: src/backend/tcop/utility.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/tcop/utility.c,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.8.2
diff -c -r1.1.1.1 -r1.1.1.1.8.2
*** src/backend/tcop/utility.c	1 Dec 2008 09:36:27 -0000	1.1.1.1
--- src/backend/tcop/utility.c	14 Feb 2009 11:30:22 -0000	1.1.1.1.8.2
***************
*** 417,427 ****
  						relOid = DefineRelation((CreateStmt *) stmt,
  												RELKIND_RELATION);
  
  						/*
  						 * Let AlterTableCreateToastTable decide if this one
  						 * needs a secondary relation too.
  						 */
- 						CommandCounterIncrement();
  						AlterTableCreateToastTable(relOid);
  					}
  					else
--- 417,432 ----
  						relOid = DefineRelation((CreateStmt *) stmt,
  												RELKIND_RELATION);
  
+ 						CommandCounterIncrement();
+ 						/*
+ 						 * Let DefinePartitions decide if partitions need to be created
+ 						 * for this table
+ 						 */
+ 						DefinePartitions((CreateStmt *)parsetree, relOid);
  						/*
  						 * Let AlterTableCreateToastTable decide if this one
  						 * needs a secondary relation too.
  						 */
  						AlterTableCreateToastTable(relOid);
  					}
  					else
Index: src/backend/utils/adt/numeric.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/utils/adt/numeric.c,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.10.1
diff -c -r1.1.1.1 -r1.1.1.1.10.1
*** src/backend/utils/adt/numeric.c	1 Dec 2008 09:36:27 -0000	1.1.1.1
--- src/backend/utils/adt/numeric.c	2 Feb 2009 11:07:12 -0000	1.1.1.1.10.1
***************
*** 3588,3594 ****
  	char	   *endptr;
  
  	tmp = DatumGetCString(DirectFunctionCall1(numeric_out,
! 											  NumericGetDatum(num)));
  
  	/* unlike float8in, we ignore ERANGE from strtod */
  	val = strtod(tmp, &endptr);
--- 3588,3594 ----
  	char	   *endptr;
  
  	tmp = DatumGetCString(DirectFunctionCall1(numeric_out,
! 		 NumericGetDatum(num)));
  
  	/* unlike float8in, we ignore ERANGE from strtod */
  	val = strtod(tmp, &endptr);
Index: src/backend/utils/adt/ruleutils.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/utils/adt/ruleutils.c,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.10.1
diff -c -r1.1.1.1 -r1.1.1.1.10.1
*** src/backend/utils/adt/ruleutils.c	1 Dec 2008 09:36:27 -0000	1.1.1.1
--- src/backend/utils/adt/ruleutils.c	2 Feb 2009 11:07:12 -0000	1.1.1.1.10.1
***************
*** 41,46 ****
--- 41,48 ----
  #include "parser/parse_func.h"
  #include "parser/parse_oper.h"
  #include "parser/parsetree.h"
+ #include "parser/parse_clause.h"
+ #include "parser/parse_expr.h"
  #include "rewrite/rewriteHandler.h"
  #include "rewrite/rewriteManip.h"
  #include "rewrite/rewriteSupport.h"
***************
*** 6157,6160 ****
--- 6159,6200 ----
  	ReleaseSysCache(tuple);
  
  	return result;
+ }
+ 
+ /*
+  * get the text corresponding to a raw expr 
+  */
+ char *
+ pg_get_expr_text(RangeVar *relation, Node *raw_expr, StringInfo buf)
+ {
+ 	deparse_context context;
+ 	Node *opex;
+ 	Node *temp;
+ 	deparse_namespace dpns;
+ 	RangeVar *old;
+ 	RangeVar *new;
+ 	ParseState *pstate = make_parsestate(NULL);
+ 
+ 	old = makeNode(RangeVar);
+ 	old->relname = relation->relname;
+ 	old->alias = makeAlias("*OLD*", NIL);
+ 
+ 	new = makeNode(RangeVar);
+ 	new->relname = relation->relname;
+ 	new->alias = makeAlias("*NEW*", NIL);
+ 
+ 	transformFromClause(pstate, list_make3(relation, old, new));
+ 	temp = transformExpr(pstate, raw_expr);
+ 
+ 	opex = (Node *)temp;
+ 	context.buf = buf;
+ 	context.namespaces = list_make1(&dpns);
+ 	context.varprefix = true;
+ 	context.prettyFlags = PRETTYFLAG_PAREN | PRETTYFLAG_INDENT ;
+ 	context.indentLevel = PRETTYINDENT_STD;
+ 	dpns.rtable = pstate->p_rtable;
+ 	dpns.outer_plan = dpns.inner_plan = NULL;
+ 
+ 	get_rule_expr(opex, &context, false);
+ 	return (context.buf)->data;
  }
Index: src/include/catalog/indexing.h
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/include/catalog/indexing.h,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.10.2
diff -c -r1.1.1.1 -r1.1.1.1.10.2
*** src/include/catalog/indexing.h	1 Dec 2008 09:36:42 -0000	1.1.1.1
--- src/include/catalog/indexing.h	23 Feb 2009 12:33:10 -0000	1.1.1.1.10.2
***************
*** 57,62 ****
--- 57,65 ----
   * index name (much less the numeric OID).
   */
  
+ DECLARE_INDEX(pg_part_partrel_index, 2337, on pg_partition using btree(parentrelid oid_ops, partrelid oid_ops, keyorder int2_ops));
+ #define PartitionParentIndexId 2337
+ 
  DECLARE_UNIQUE_INDEX(pg_aggregate_fnoid_index, 2650, on pg_aggregate using btree(aggfnoid oid_ops));
  #define AggregateFnoidIndexId  2650
  
Index: src/include/commands/tablecmds.h
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/include/commands/tablecmds.h,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.10.6
diff -c -r1.1.1.1 -r1.1.1.1.10.6
*** src/include/commands/tablecmds.h	1 Dec 2008 09:36:42 -0000	1.1.1.1
--- src/include/commands/tablecmds.h	17 Mar 2009 12:50:55 -0000	1.1.1.1.10.6
***************
*** 18,23 ****
--- 18,30 ----
  #include "utils/relcache.h"
  
  
+ typedef struct partitionInfo
+ {
+     char    partitionName[20];
+     Value   minValue;
+     Value   maxValue;
+ }partitionInfo;
+ 
  extern Oid	DefineRelation(CreateStmt *stmt, char relkind);
  
  extern void RemoveRelations(DropStmt *drop);
***************
*** 69,73 ****
--- 76,85 ----
  extern void AtEOSubXact_on_commit_actions(bool isCommit,
  							  SubTransactionId mySubid,
  							  SubTransactionId parentSubid);
+ 
+ extern void	DefinePartitions(CreateStmt *stmt, Oid parentRelId);
+ extern int GetPartitionsCount(Oid parentOid);
+ extern int GetPartitionsCountAtt(Oid parentOid, Oid attNum);
+ extern int ValidateRanges(PartitionAttrs *partAttr, Oid parentRelOid, Oid *partitionRelOids);
  
  #endif   /* TABLECMDS_H */
Index: src/include/nodes/nodes.h
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/include/nodes/nodes.h,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.2.10.3
diff -c -r1.1.1.2 -r1.1.1.2.10.3
*** src/include/nodes/nodes.h	1 Dec 2008 09:38:07 -0000	1.1.1.2
--- src/include/nodes/nodes.h	17 Mar 2009 12:50:55 -0000	1.1.1.2.10.3
***************
*** 362,367 ****
--- 362,371 ----
  	T_XmlSerialize,
  	T_WithClause,
  	T_CommonTableExpr,
+ 	T_PartitionAttrs,
+ 	T_Partition,
+ 	T_UpdatePartitionStmt,
+ 	T_SplitPartitionStmt,
  
  	/*
  	 * TAGS FOR RANDOM OTHER STUFF
Index: src/include/nodes/parsenodes.h
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/include/nodes/parsenodes.h,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.2.8.6
diff -c -r1.1.1.2 -r1.1.1.2.8.6
*** src/include/nodes/parsenodes.h	1 Dec 2008 09:38:07 -0000	1.1.1.2
--- src/include/nodes/parsenodes.h	17 Mar 2009 12:50:55 -0000	1.1.1.2.8.6
***************
*** 1025,1031 ****
  	AT_EnableReplicaRule,		/* ENABLE REPLICA RULE name */
  	AT_DisableRule,				/* DISABLE RULE name */
  	AT_AddInherit,				/* INHERIT parent */
! 	AT_DropInherit				/* NO INHERIT parent */
  } AlterTableType;
  
  typedef struct AlterTableCmd	/* one subcommand of an ALTER TABLE */
--- 1025,1036 ----
  	AT_EnableReplicaRule,		/* ENABLE REPLICA RULE name */
  	AT_DisableRule,				/* DISABLE RULE name */
  	AT_AddInherit,				/* INHERIT parent */
! 	AT_DropInherit,				/* NO INHERIT parent */
! 	AT_AddPartition,			/* add partition */
! 	AT_DropPartitionByName,		/* drop partition by name. */
! 	AT_DropPartitionByRange,	/* drop partition by range. */
! 	AT_UpdatePartition,			/* Update the range partition. */
! 	AT_SplitPartition			/* Split range partition. */
  } AlterTableType;
  
  typedef struct AlterTableCmd	/* one subcommand of an ALTER TABLE */
***************
*** 1216,1221 ****
--- 1221,1227 ----
  	List	   *options;		/* options from WITH clause */
  	OnCommitAction oncommit;	/* what do we do at COMMIT? */
  	char	   *tablespacename; /* table space to use, or NULL */
+ 	Node	   *partAttr;		/* partitioning related information */
  } CreateStmt;
  
  /* ----------
***************
*** 1254,1271 ****
  	CONSTR_ATTR_IMMEDIATE
  } ConstrType;
  
  typedef struct Constraint
  {
! 	NodeTag		type;
! 	ConstrType	contype;
! 	char	   *name;			/* name, or NULL if unnamed */
! 	Node	   *raw_expr;		/* expr, as untransformed parse tree */
! 	char	   *cooked_expr;	/* expr, as nodeToString representation */
! 	List	   *keys;			/* String nodes naming referenced column(s) */
! 	List	   *options;		/* options from WITH clause */
! 	char	   *indexspace;		/* index tablespace for PKEY/UNIQUE
! 								 * constraints; NULL for default */
  } Constraint;
  
  /* ----------
   * Definitions for FOREIGN KEY constraints in CreateStmt
--- 1260,1338 ----
  	CONSTR_ATTR_IMMEDIATE
  } ConstrType;
  
+ 
+ /*
+  * Enumeration which defines the various possibilites for the partitioning
+  * function.
+  */
+ typedef enum PartitionFunction {
+         PART_UNDEFINED,
+         PART_LIST,
+         PART_RANGE,
+         PART_HASH
+ } PartitionFunction;
+ 
+ 
  typedef struct Constraint
  {
! 	NodeTag				type;
! 	List 				*min_value;
! 	List				*max_value;
! 	List				*partition_list_values;
! //	ConstrType			contype;
! 	PartitionFunction	contype;
! 	char	   			*name;			/* name, or NULL if unnamed */
! 	Node	   			*raw_expr;		/* expr, as untransformed parse tree */
! 	char	   			*cooked_expr;	/* expr, as nodeToString representation */
! 	List	   			*keys;			/* String nodes naming referenced column(s) */
! 	List	   			*options;		/* options from WITH clause */
! 	char	   			*indexspace;	/* index tablespace for PKEY/UNIQUE
! 								 			* constraints; NULL for default */
  } Constraint;
+ 
+ //typedef struct PartitionConstraint
+ //{
+ //	Node			*min_value;
+ //  	Node			*max_value;
+ //	List 			*list_partition_values;
+ //	PartitionFunction 	contype;
+ //	char	   		*name;			/* name, or NULL if unnamed */
+ //	Node	   		*raw_expr;		/* expr, as untransformed parse tree */
+ //	char	   		*cooked_expr;		/* expr, as nodeToString representation */
+ //	List	   		*keys;			/* String nodes naming referenced column(s) */
+ //	List	   		*options;		/* options from WITH clause */
+ //	char	   		*indexspace;		/* index tablespace for PKEY/UNIQUE
+ //								 * constraints; NULL for default */
+ // } PartitionConstraint;
+ 
+ typedef struct Partition {
+ 	NodeTag		type;
+ 	RangeVar	*partName;          /* Name of the partition */
+ 	Constraint	*partitionCheck;    /* per partition constraint */
+ 	char 		*tablespacename;	/* tablespace name*/ 
+ } Partition;
+ 
+ typedef struct UpdatePartitionStmt
+ {
+ 	NodeTag		type;
+ 	Partition 	*prev;
+ 	Partition 	*after;
+ }UpdatePartitionStmt;
+ 
+ typedef struct SplitPartitionStmt
+ {
+ 	NodeTag 	type;
+ 	List		*partNames;
+ 	List		*splitValues;
+ }SplitPartitionStmt;
+ 
+ typedef struct PartitionAttrs {
+ 	NodeTag				type;
+ 	int     			numberOfPartitions; /* Number of partitions */
+ 	List    			*partitions;  		/* The list of partitions */
+ 	PartitionFunction 	partFunc; 			/* type of partition */
+ 	List 				*colName;           /* partition column name */
+ } PartitionAttrs;
  
  /* ----------
   * Definitions for FOREIGN KEY constraints in CreateStmt
Index: src/include/utils/builtins.h
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/include/utils/builtins.h,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.10.1
diff -c -r1.1.1.1 -r1.1.1.1.10.1
*** src/include/utils/builtins.h	1 Dec 2008 09:36:46 -0000	1.1.1.1
--- src/include/utils/builtins.h	2 Feb 2009 11:07:12 -0000	1.1.1.1.10.1
***************
*** 16,21 ****
--- 16,23 ----
  
  #include "fmgr.h"
  #include "nodes/parsenodes.h"
+ #include "nodes/primnodes.h"
+ #include "lib/stringinfo.h"
  
  /*
   *		Defined in adt/
***************
*** 562,567 ****
--- 564,571 ----
  extern const char *quote_identifier(const char *ident);
  extern char *quote_qualified_identifier(const char *namespace,
  						   const char *ident);
+ extern char *pg_get_expr_text(RangeVar *relation, 
+ 						Node *raw_expr, StringInfo buf);
  
  /* tid.c */
  extern Datum tidin(PG_FUNCTION_ARGS);
Index: src/test/regress/regress.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/test/regress/regress.c,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.10.8
diff -c -r1.1.1.1 -r1.1.1.1.10.8
*** src/test/regress/regress.c	1 Dec 2008 09:36:47 -0000	1.1.1.1
--- src/test/regress/regress.c	9 Mar 2009 12:55:31 -0000	1.1.1.1.10.8
***************
*** 11,16 ****
--- 11,34 ----
  #include "executor/executor.h"	/* For GetAttributeByName */
  #include "commands/sequence.h"	/* for nextval() */
  
+ #include "postgres.h"
+ #include "executor/spi.h"
+ #include "commands/trigger.h"
+ 
+ #include "optimizer/plancat.h" 
+ #include "utils/fmgroids.h"
+ #include "catalog/pg_partition.h"
+ #include "catalog/indexing.h"
+ #include "utils/tqual.h"
+ #include "utils/lsyscache.h"
+ #include "access/hash.h"
+ 
+ extern Datum trigf(PG_FUNCTION_ARGS);
+ 
+ PG_FUNCTION_INFO_V1(trigf);
+ 
+ #define     ItemPointerGetDatum(X)   PointerGetDatum(X)
+ 
  #define P_MAXDIG 12
  #define LDELIM			'('
  #define RDELIM			')'
***************
*** 27,37 ****
  extern int	oldstyle_length(int n, text *t);
  extern Datum int44in(PG_FUNCTION_ARGS);
  extern Datum int44out(PG_FUNCTION_ARGS);
! 
  #ifdef PG_MODULE_MAGIC
  PG_MODULE_MAGIC;
  #endif
  
  
  /*
   * Distance from a point to a path
--- 45,365 ----
  extern int	oldstyle_length(int n, text *t);
  extern Datum int44in(PG_FUNCTION_ARGS);
  extern Datum int44out(PG_FUNCTION_ARGS);
! extern Oid find_inheritance_parent(Oid inhrelid);
! extern Oid get_relevent_hash_partition(HeapTuple tuple, Relation rel);
! Datum  partition_update_trigger(PG_FUNCTION_ARGS); 
! Datum  partition_constraints_hash(PG_FUNCTION_ARGS);
! Datum  partition_insert_trigger_hash(PG_FUNCTION_ARGS);
! Datum  partition_insert_trigger(PG_FUNCTION_ARGS);
  #ifdef PG_MODULE_MAGIC
  PG_MODULE_MAGIC;
  #endif
  
+ PG_FUNCTION_INFO_V1(partition_update_trigger);
+ 
+ /*
+  * Update trigger for all partitions.
+  * Update is implemented as delete + insert operation.
+  * Delete the OLD row from child table and insert the NEW
+  * row on parent table.
+  */
+ 
+ Datum
+ partition_update_trigger(PG_FUNCTION_ARGS)
+ {
+     int col;
+     TriggerData *trigdata = (TriggerData *) fcinfo->context;
+     HeapTuple   trigtuple = trigdata->tg_trigtuple;
+     HeapTuple   newtuple  = trigdata->tg_newtuple;
+ 	HeapTuple 	dummyTuple = NULL;
+ 
+     Relation    parent_relation = RelationIdGetRelation(
+                                     find_inheritance_parent (
+ 									    RelationGetRelid(trigdata->tg_relation)));
+ 
+     StringInfo	delquery = makeStringInfo();
+     StringInfo	insquery = makeStringInfo();
+     bool        isnull;
+ 
+ 	resetStringInfo(delquery);
+ 
+     appendStringInfo( delquery, " delete from %s where ctid = '%s';",
+                     RelationGetRelationName(trigdata->tg_relation),
+                      DatumGetCString(OidFunctionCall1(F_TIDOUT,
+                     ItemPointerGetDatum(&trigtuple->t_self) ))
+                 );
+ 
+ //    elog(NOTICE,"query is :- %s",delquery->data);
+     SPI_connect();
+     SPI_exec(delquery->data,1);
+     SPI_finish();
+ 
+     appendStringInfo(insquery," insert into %s values ('", RelationGetRelationName(parent_relation));
+     for ( col = 1; col <= trigdata->tg_relation->rd_att->natts; col++  )
+     {
+ 
+         Oid typoutput;
+ 		bool typIsVarlen ;
+         getTypeOutputInfo ( trigdata->tg_relation->rd_att->attrs[col-1]->atttypid , &typoutput , &typIsVarlen );
+         Datum d = heap_getattr(newtuple,col,trigdata->tg_relation->rd_att,&isnull);
+         appendStringInfo(insquery ,"%s%s",
+                 DatumGetCString (OidFunctionCall1(typoutput,d)),
+                 col < (trigdata->tg_relation->rd_att->natts) ? "','" :"');"
+                 );
+     }
+ 
+     SPI_connect();
+     SPI_exec(insquery->data,1);
+     SPI_finish();
+ 
+     RelationClose(parent_relation);
+ 
+ 	/* Form a dummy-tuple to count no. of rows modified. */
+ 	dummyTuple = palloc(newtuple->t_len);
+ 	dummyTuple->t_len = -1;
+ 
+     return PointerGetDatum(dummyTuple);
+ }
+ 
+ /*
+  * Constaints for hash partitions are implemented by monitoring inserts to child tables
+  * using following trigger which computes the hash value of partition key attributes 
+  * and allows insert iff it matches with its designated hash value as specified  
+  * in pg_partition catalog table.
+  */
+ PG_FUNCTION_INFO_V1(partition_constraints_hash);
+ Datum
+ partition_constraints_hash(PG_FUNCTION_ARGS)
+ {
+     TriggerData *trigdata = (TriggerData *) fcinfo->context;
+     HeapTuple   trigtuple = trigdata->tg_trigtuple;
+     Relation    relation = trigdata->tg_relation;
+     Relation 	pg_partrel;
+     Oid 		relation_id;
+ 	ScanKeyData skey;
+ 	SysScanDesc pg_partscan;
+ 	HeapTuple   pg_parttup;
+ 	int         hash_partition_entries = 0;
+ 	List        *distinct_part_key_list=NULL;
+ 	StringInfo	str_to_hash = makeStringInfo();
+ 	unsigned int hashValueFromCatalog;
+ 	Oid			parentOid;
+ 
+     /* make sure it's called as a trigger at all */
+     if (!CALLED_AS_TRIGGER(fcinfo))
+         elog(ERROR, "partition_insert_trigger: not called by trigger manager");
+ 
+     /* Sanity checks */
+     if (!TRIGGER_FIRED_BY_INSERT(trigdata->tg_event) || !TRIGGER_FIRED_BEFORE(trigdata->tg_event))
+         elog(ERROR, "partition_insert_trigger: not called on insert before");
+ 
+     relation_id = RelationGetRelid(relation);
+ 
+     ScanKeyInit(&skey,
+                 Anum_pg_partition_partrelid,
+                 BTEqualStrategyNumber, F_OIDEQ,
+                 ObjectIdGetDatum(RelationGetRelid(relation)));
+ 
+     pg_partrel = heap_open(PartitionRelationId, AccessShareLock);
+     pg_partscan = systable_beginscan(pg_partrel, PartitionParentIndexId, true,
+                                 SnapshotNow, 1, &skey);
+ 
+     while (HeapTupleIsValid(pg_parttup= systable_getnext(pg_partscan)))
+     {
+         bool            isnull, typbyval;
+         int16           len;
+         bool            isVariableLength;
+         Oid             typoutput;
+ 
+         /* Instead of pg_part Use heap_getattr for accessing bytea coluns */
+         Form_pg_partition pg_part = (Form_pg_partition) GETSTRUCT(pg_parttup);
+ 
+ 		if(pg_part->partrelid == RelationGetRelid(relation))
+ 		{
+         	if(pg_part->parttype == PART_HASH)
+ 	        {
+     	        if (!list_member_int(distinct_part_key_list, pg_part->partkey))
+         	    {
+             	    distinct_part_key_list = lappend_int(distinct_part_key_list, pg_part->partkey);
+ 
+                 	/* Get attribute from tuple */
+ 	                Datum attr      = heap_getattr(trigtuple, pg_part->partkey, relation->rd_att, &isnull);
+ 
+         	        /* Get len and typbyval from pg_type */
+             	    get_typlenbyval(pg_part->keytype, &len, &typbyval);
+ 
+         	        /* Read the list value */
+             	    getTypeOutputInfo(pg_part->keytype, &typoutput, &isVariableLength);
+                 	appendStringInfo(str_to_hash, DatumGetCString(OidFunctionCall1(typoutput, attr)));
+ 	
+ 					parentOid = pg_part->parentrelid;
+ 					hashValueFromCatalog = heap_getattr (pg_parttup, Anum_pg_partition_hashval, pg_partrel->rd_att, &isnull);
+         	    }
+         	}
+ 		}
+     }
+ 
+     systable_endscan(pg_partscan);
+     heap_close(pg_partrel, AccessShareLock);
+ 
+     /*Scan key to scan pg_partition table on parentrelid*/
+     ScanKeyInit(&skey,
+                 Anum_pg_partition_parentrelid,
+                 BTEqualStrategyNumber, F_OIDEQ,
+                 ObjectIdGetDatum(parentOid));
+ 
+     pg_partrel = heap_open(PartitionRelationId, AccessShareLock);
+     pg_partscan = systable_beginscan(pg_partrel, PartitionParentIndexId, true,
+                                 SnapshotNow, 1, &skey);
+ 
+ 	hash_partition_entries = 0;
+ 
+     while (HeapTupleIsValid(pg_parttup= systable_getnext(pg_partscan)))
+     {
+         /* Instead of pg_part Use heap_getattr for accessing bytea coluns */
+         Form_pg_partition pg_part = (Form_pg_partition) GETSTRUCT(pg_parttup);
+ 
+         if(pg_part->parttype == PART_HASH)
+         {
+             /* Increase the no. of hash partition entries count. */
+ 			hash_partition_entries++;
+ 		}
+ 	}
+ 
+     systable_endscan(pg_partscan);
+     heap_close(pg_partrel, AccessShareLock);
+ 
+     unsigned int hashValue = DatumGetUInt32(hash_any(str_to_hash->data, strlen(str_to_hash->data))) %
+                 (int)(hash_partition_entries / distinct_part_key_list->length);
+ 
+ //	elog(NOTICE, "String to be hashed : %s", str_to_hash->data);
+ 
+ 	if(hashValueFromCatalog != hashValue)
+ 		elog(ERROR, "This row can not be inserted. Invalid hash value '%d'; expected '%d'", hashValue, hashValueFromCatalog);
+ 	
+     return PointerGetDatum(trigtuple);
+ }
+ 
+ PG_FUNCTION_INFO_V1(partition_insert_trigger_hash);
+ Datum
+ partition_insert_trigger_hash(PG_FUNCTION_ARGS)
+ {
+     TriggerData *trigdata = (TriggerData *) fcinfo->context;
+     HeapTuple   trigtuple= trigdata->tg_trigtuple;
+     Relation    parent_relation = trigdata->tg_relation;
+ 
+     char        *child_table_name;
+     Relation 	child_table_relation;
+     Oid 		relation_id,parent_reloid;
+ 
+     /* make sure it's called as a trigger at all */
+     if (!CALLED_AS_TRIGGER(fcinfo))
+         elog(ERROR, "partition_insert_trigger: not called by trigger manager");
+ 
+     /* Sanity checks */
+     if (!TRIGGER_FIRED_BY_INSERT(trigdata->tg_event) || !TRIGGER_FIRED_BEFORE(trigdata->tg_event))
+         elog(ERROR, "partition_insert_trigger: not called on insert before");
+ 
+     parent_reloid = RelationGetRelid(parent_relation);
+ 
+     relation_id = get_relevent_hash_partition(trigtuple, parent_relation);
+     if (relation_id == InvalidOid)
+         elog(ERROR, "partition_insert_trigger: Invalid child table %s", child_table_name);
+ 
+     child_table_relation = RelationIdGetRelation(relation_id);
+     if (child_table_relation == NULL)
+     elog(ERROR, "partition_insert_trigger: Failed to locate relation for child table %s", child_table_name);
+ 
+     ResultRelInfo *resultRelInfo;
+     TupleTableSlot *slot;
+     EState *estate= CreateExecutorState();
+ 
+     resultRelInfo = makeNode(ResultRelInfo);
+     resultRelInfo->ri_RangeTableIndex = 1;
+     resultRelInfo->ri_RelationDesc = child_table_relation;
+ 
+     estate->es_result_relations = resultRelInfo;
+     estate->es_num_result_relations = 1;
+     estate->es_result_relation_info = resultRelInfo;
+ 
+ 	/* Set up a tuple slot too */
+     slot = MakeSingleTupleTableSlot(trigdata->tg_relation->rd_att);
+     ExecStoreTuple(trigtuple, slot, InvalidBuffer, false);
+ 
+ 	ExecConstraints(resultRelInfo, slot, estate);
+ 
+     heap_insert(child_table_relation, trigtuple, GetCurrentCommandId(true), 0, NULL);
+     RelationClose(child_table_relation);
+     ExecDropSingleTupleTableSlot(slot);
+     FreeExecutorState (estate);
+ 	
+ 	/* Form a dummy-tuple to count no. of rows modified. */
+ 	trigtuple->t_len = -1;
+ 
+     return PointerGetDatum(trigtuple);
+ }
+ 
+ Oid
+ get_relevent_partition(HeapTuple tuple, Relation rel);
+ 
+ PG_FUNCTION_INFO_V1(partition_insert_trigger);
+ Datum
+ partition_insert_trigger(PG_FUNCTION_ARGS)
+ {
+     TriggerData *trigdata = (TriggerData *) fcinfo->context;
+     HeapTuple   trigtuple= trigdata->tg_trigtuple;
+     Relation    parent_relation = trigdata->tg_relation;
+ 
+     char        *child_table_name;
+     Relation child_table_relation;
+     Oid relation_id,parent_reloid;
+ 
+     /* make sure it's called as a trigger at all */
+     if (!CALLED_AS_TRIGGER(fcinfo))
+         elog(ERROR, "partition_insert_trigger: not called by trigger manager");
+ 
+     /* Sanity checks */
+     if (!TRIGGER_FIRED_BY_INSERT(trigdata->tg_event) || !TRIGGER_FIRED_BEFORE(trigdata->tg_event))
+         elog(ERROR, "partition_insert_trigger: not called on insert before");
+ 
+ 	parent_reloid = RelationGetRelid(parent_relation);
+ 
+ 	relation_id = get_relevent_partition(trigtuple, parent_relation);
+     if (relation_id == InvalidOid)
+         elog(ERROR, "Could not find valid partition ... ");
+ 
+     child_table_relation = RelationIdGetRelation(relation_id);
+     if (child_table_relation == NULL)
+     elog(ERROR, "partition_insert_trigger: Failed to locate relation for child table %s", child_table_name);
+ 
+     ResultRelInfo *resultRelInfo;
+     TupleTableSlot *slot;
+     EState *estate= CreateExecutorState();
+ 
+     resultRelInfo = makeNode(ResultRelInfo);
+     resultRelInfo->ri_RangeTableIndex = 1;
+     resultRelInfo->ri_RelationDesc = child_table_relation;
+ 
+     estate->es_result_relations = resultRelInfo;
+     estate->es_num_result_relations = 1;
+     estate->es_result_relation_info = resultRelInfo;
+ 
+ 	/* Set up a tuple slot too */
+     slot = MakeSingleTupleTableSlot(trigdata->tg_relation->rd_att);
+     ExecStoreTuple(trigtuple, slot, InvalidBuffer, false);
+ 
+ 	ExecConstraints(resultRelInfo, slot, estate);
+ 
+     heap_insert(child_table_relation, trigtuple, GetCurrentCommandId(true), 0, NULL);
+     RelationClose(child_table_relation);
+     ExecDropSingleTupleTableSlot(slot);
+     FreeExecutorState (estate);
+ 
+ 	/* Form a dummy-tuple to count no. of rows modified. */
+ 	trigtuple->t_len = -1;
+ 
+     return PointerGetDatum(trigtuple);
+ }
  
  /*
   * Distance from a point to a path
